%global dlrn_nvr ironic-python-agent-5.0.5.dev31-2.20230727073802.8744b0f
%global dlrn 1
%define upstream_version 5.0.5.dev31
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility
%{?!_licensedir:%global license %%doc}
%{!?upstream_version: %global upstream_version %{version}}

%global with_doc 0
%global sname ironic-python-agent

Name:       openstack-ironic-python-agent
Summary:    A python agent for provisioning and deprovisioning bare metal servers
Version: 5.0.5
Release: 2.20230727073802.8744b0f%{?dist}
License:    ASL 2.0
URL:        https://github.com/openstack/ironic-python-agent

Source0: ironic-python-agent-5.0.5.dev31-2.20230727073802.8744b0f.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=8744b0fe601a2fbd6b2a8b8d61502d1eafa94ce5
Patch0001: 0001-Fix-UTF-16-result-handling-for-efibootmgr.patch

Source1:    openstack-ironic-python-agent.service
Source2:    ironic-python-agent-dist.conf

BuildArch:  noarch
BuildRequires:  python%{pyver}-setuptools
BuildRequires:  python%{pyver}-pbr
BuildRequires:  python%{pyver}-devel
BuildRequires:  systemd
# These packages are required for running unit tests
BuildRequires: python%{pyver}-eventlet
BuildRequires: python%{pyver}-ironic-lib
BuildRequires: python%{pyver}-iso8601
BuildRequires: python%{pyver}-mock
BuildRequires: python%{pyver}-oslo-config
BuildRequires: python%{pyver}-oslo-concurrency
BuildRequires: python%{pyver}-oslo-log
BuildRequires: python%{pyver}-oslo-serialization
BuildRequires: python%{pyver}-oslo-service
BuildRequires: python%{pyver}-oslo-utils
BuildRequires: python%{pyver}-oslotest
BuildRequires: python%{pyver}-pecan
BuildRequires: python%{pyver}-psutil
BuildRequires: python%{pyver}-requests
BuildRequires: python%{pyver}-six
BuildRequires: python%{pyver}-stevedore
BuildRequires: python%{pyver}-wsme
BuildRequires: openstack-macros
BuildRequires: python%{pyver}-stestr
# Handle python2 exception
%if %{pyver} == 2
BuildRequires: python-netifaces
BuildRequires: python-pint
BuildRequires: python-pyudev
BuildRequires: python-rtslib
%else
BuildRequires: python%{pyver}-netifaces
BuildRequires: python%{pyver}-pint
BuildRequires: python%{pyver}-pyudev
BuildRequires: python%{pyver}-rtslib
%endif

Requires: python%{pyver}-ironic-python-agent = %{version}-%{release}
%{?systemd_requires}

%description
An agent for controlling and deploying Ironic controlled bare metal nodes.

The ironic-python-agent works with the agent driver in Ironic to provision the
node. Starting with ironic-python-agent running on a ramdisk on the
unprovisioned node, Ironic makes API calls to ironic-python-agent to provision
the machine. This allows for greater control and flexibility of the entire
deployment process.

The ironic-python-agent may also be used with the original Ironic pxe drivers
as of the Kilo OpenStack release.

%package -n python%{pyver}-ironic-python-agent
Summary:    Python library for the ironic python agent.
%{?python_provide:%python_provide python%{pyver}-ironic-python-agent}

Requires: python%{pyver}-pbr
Requires: python%{pyver}-eventlet
Requires: python%{pyver}-ironic-lib >= 2.17.0
Requires: python%{pyver}-iso8601
Requires: python%{pyver}-netaddr >= 0.7.18
Requires: python%{pyver}-oslo-config >= 2:5.2.0
Requires: python%{pyver}-oslo-concurrency >= 3.26.0
Requires: python%{pyver}-oslo-log >= 3.36.0
Requires: python%{pyver}-oslo-serialization >= 2.18.0
Requires: python%{pyver}-oslo-service >= 1.24.0
Requires: python%{pyver}-oslo-utils >= 3.33.0
Requires: python%{pyver}-pecan
Requires: python%{pyver}-psutil
Requires: python%{pyver}-requests
Requires: python%{pyver}-six
Requires: python%{pyver}-stevedore >= 1.20.0
Requires: python%{pyver}-wsme
# Handle python2 exception
%if %{pyver} == 2
Requires: python-netifaces
Requires: python-pint
Requires: python-pyudev
Requires: python-rtslib
Requires: systemd-python
%else
Requires: python%{pyver}-netifaces
Requires: python%{pyver}-pint
Requires: python%{pyver}-pyudev
Requires: python%{pyver}-rtslib
Requires: python%{pyver}-systemd
%endif

%if 0%{?rhel} > 7
# RHEL8 requires a network-scripts package for ifcfg backwards compatibility
Requires:   network-scripts
%endif

%description -n python%{pyver}-ironic-python-agent
Python library for ironic python agent.

%if 0%{?with_doc}
%package -n python-ironic-python-agent-doc
Summary:    Documentation for ironic python agent.
BuildRequires: python%{pyver}-sphinx
BuildRequires: python%{pyver}-sphinxcontrib-httpdomain
BuildRequires: python%{pyver}-sphinxcontrib-pecanwsme
BuildRequires: python%{pyver}-openstackdocstheme

%description -n python-ironic-python-agent-doc
Documentation for ironic python agent.
%endif

%prep
%autosetup -v -p 1 -n ironic-python-agent-%{upstream_version}

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
%{pyver_build}

%install
%{pyver_install}

%if 0%{?with_doc}
export PYTHONPATH=.
sphinx-build-%{pyver} -b html -d doc/build/doctrees doc/source doc/build/html
# Remove build docs leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

# install systemd scripts
mkdir -p %{buildroot}%{_unitdir}
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}

# Install distribution config
install -p -D -m 640 %{SOURCE2} %{buildroot}/%{_sysconfdir}/ironic-python-agent/ironic-python-agent-dist.conf

%check

export PYTHON=%{pyver_bin}
stestr-%{pyver} --test-path ironic_python_agent/tests/unit run

%files
%doc README.rst
%license LICENSE
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/ironic-python-agent
%{_bindir}/ironic-python-agent
%{_bindir}/ironic-collect-introspection-data
%{_unitdir}/openstack-ironic-python-agent.service

%files -n python%{pyver}-ironic-python-agent
%license LICENSE
%{pyver_sitelib}/ironic_python_agent
%{pyver_sitelib}/ironic_python_agent*.egg-info

%if 0%{?with_doc}
%files -n python-ironic-python-agent-doc
%doc doc/build/html
%license LICENSE
%endif

%post
%systemd_post openstack-ironic-python-agent.service

%preun
%systemd_preun openstack-ironic-python-agent.service

%postun
%systemd_postun_with_restart openstack-ironic-python-agent.service

%changelog
* Thu Jul 27 2023 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20230727073802.8744b0f
- Update patches
- Use utf-16-le if BOM not present

* Tue May 02 2023 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20230502215002.8330df9
- Fix UTF-16 result handling for efibootmgr (rhbz#2184201)

* Sat Jan 28 2023 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20230128064937.8330df9
- Update patches
- Make reno ignore bugfix eol tags

* Fri Dec 02 2022 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20221203045219.dd9dc7b
- Update patches
- CI: Zuul no longer respects queue param

* Tue Oct 25 2022 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20221025195121.26e849c
- Use utf-16-le if BOM not present (rhbz#2134529)

* Thu Feb 03 2022 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20220204025305.26e849c
- Update patches
- Remove legacy centos7 build jobs

* Wed Jan 05 2022 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20220106024842.df187ae
- Update patches
- Re-read the partition table with partx -a

* Tue Nov 23 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20211124024852.52735a8
- Update patches
- Fix UEFI record regex
- Delete EFI boot entry duplicate labels first
- Output verbose info from efibootmgr

* Tue Jul 13 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210714024807.f0204fe
- Update patches
- Reduce logging verbosity when collecting logs

* Thu Jul 01 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210702024809.388b93a
- Update patches
- Train only - Fix py3 support for bootloader default config load

* Mon Jun 28 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210629024817.3aa76b4
- Update patches
- Fix getting memory size in some lshw output
- Add function to calculate memory

* Mon Jun 14 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210615024811.b6f02de
- Update patches
- Utilize CSV file for EFI loader selection
- Make _get_efi_bootloaders return relative paths

* Thu Jun 10 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210611024817.928db63
- Update patches
- Fix py27 compatability for train

* Thu Jun 03 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210603124809.7afadbc
- Update patches
- Add fstab pointer to EFI partition
- Limit qemu-img execution arenas
- Increase the memory limit for qemu-img

* Tue Jun 01 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210602034808.5e518c9
- Update patches

* Tue Jun 01 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210602024808.5e518c9
- Update patches
- Prevent broken partition image UEFI deploys

* Tue Jun 01 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210602014810.e3da253
- Add fstab pointer to EFI partition
- Prevent broken partition image UEFI deploys

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210529034815.e3da253
- Update patches
- Fix NVMe Partition image on UEFI

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.5-2.20210528114830.9f2ef8a
- Update patches

* Wed Apr 14 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.4-1
- Update patches
- Option to enable bootloader config failure bypass
- More refactoring of the image module
- Mount all vfat partitions before calling grub2
- Refactor part of image module

* Tue Mar 30 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.4-1
- Update patches
- Do not try to read raw disk data as unicode

* Tue Feb 02 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.4-1
- Update patches

* Mon Jan 11 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches

* Mon Jan 11 2021 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- CI: Remove l-c job, set ipa-b to 2.2.0

* Thu Dec 17 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches

* Mon Oct 12 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- Fix: make Intel CNA hardware manager none generic

* Wed Oct 07 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- Increase memory for tinyipa jobs

* Wed Aug 12 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- Fix bootloader install issue with MDRAID

* Sun Aug 09 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- Fix TypeError on agent lookup failure
- Prevent un-needed iscsi cleanup

* Wed Aug 05 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- Ignore devices with size 0 when collecting inventory

* Tue Aug 04 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches
- Pin Ironic Tempest Plugin

* Tue Jul 21 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches

* Thu Jul 16 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches

* Wed Jul 08 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.3-1
- Update patches

* Tue Jul 07 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches
- Fix serializing ironic-lib exceptions

* Mon Jul 06 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches
- Limit Inspection->Lookup->Heartbeat lag

* Thu Jul 02 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches
- Extend retries to 9, 10 seconds apart.

* Thu Jul 02 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches
- Add full download retries

* Thu Jul 02 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches
- Add timeout operations to try and prevent hang on read()

* Wed Jul 01 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches
- Fix confusing logging when running asynchronous commands
- Omit configdrive and system_logs from logging

* Thu May 21 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.2-1
- Update patches

* Tue Apr 28 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- Rescan after restarting the md device

* Sat Apr 25 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- Add timeout and retries when connection to an image server

* Fri Apr 17 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- A boot partition on a GPT disk should be considered an EFI partition

* Thu Mar 26 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- Return false for MBR bootloader check on UEFI machines

* Wed Mar 18 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- Rescan devices before performing uefi checks

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- Fixes error handling if efibootmgr is not present in ramdisk

* Fri Feb 28 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches
- Ignore pyudev errors about device number
- Catch ValueError for FIPS 140-2 mode

* Mon Feb 10 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches

* Fri Feb 07 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.1-1
- Update patches

* Tue Feb 04 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches
- Skip read-only devices with metadata erase

* Fri Jan 31 2020 Bob Fournier <bfournie@redhat.com> 5.0.1-0.20200123140814.025b790
- Skip read-only devices with metadata erase (rhbz#1796604)

* Thu Jan 23 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches
- Merge "Avoid grub2-install when on UEFI boot mode" into stable/train
- Merge "Search for efi partition" into stable/train
- Merge "Don't try to put a bootloader in place when bootable" into stable/train
- Avoid grub2-install when on UEFI boot mode
- Search for efi partition
- Don't try to put a bootloader in place when bootable

* Wed Jan 22 2020 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches
- Merge "Skip nic numa_node discovery if it's not assigned to a numa_node" into stable/train
- Set rd.md.uuid kernel parameter when deploying on software raid
- Skip nic numa_node discovery if it's not assigned to a numa_node

* Mon Nov 25 2019 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches
- Bump up ipa-ip-lookup-attempts to 6

* Mon Oct 21 2019 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches
- Correct string formatting in logging

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches
- Last resort fallback to find a partition

* Tue Oct 01 2019 OSP Prod Chain <dev-null@redhat.com> 5.0.0-1
- Update patches

* Mon Sep 30 2019 RDO <dev@lists.rdoproject.org> 5.0.0-1
- Update to 5.0.0


